/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2018, Natural Language Processing Lab, Northestern University.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Created by: XIAO Tong (xiaotong@mail.neu.edu.cn) 2018-07-10
 */

//#define CRTDBG_MAP_ALLOC
//#include <stdlib.h>
//#include <crtdbg.h>

#include <stdio.h>
#include "./network/XNet.h"
#include "./tensor/XUtility.h"
#include "./tensor/function/FHeader.h"
#include "./tensor/core/CHeader.h"
#include "./sample/fnnlm/FNNLM.h"
#include "./sample/transformer/Transformer.h"



using namespace nts;
using namespace fnnlm;
using namespace transformer;

int main( int argc, const char ** argv )
{
    /*_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF);
    _CrtSetBreakAlloc(2708);*/

    TransformerMain(argc - 1, argv + 1);

    //XTensor singleScore, singleIdx, score;
    //InitTensor3DV2(&score, 2, 1, 136160);
    ////score.SetDataRand(0, 1);
    //InitTensor1DV2(&singleIdx, 1, X_INT);
    //singleIdx.Set1DInt(1, 0);

    //singleIdx.Dump(stderr);
    //singleScore = Select(score, singleIdx, 0);
    //XTensor s, i;
    //InitTensor3DV2(&s, 2, 1, 4);
    //InitTensor3DV2(&i, 2, 1, 4, X_INT);
    //TopK(score, s, i, -1, 4);
    //i.Dump(stderr, "single score:\n");

    //_CrtDumpMemoryLeaks();
    
    return 0;
}

